#include <net/sock.h>
#include <linux/netlink.h>
#include <linux/skbuff.h>
  

#define NETLINK_USER 31

struct sock *nl_sk = NULL;
struct nlmsghdr *nlh;
int pid;
struct sk_buff *skb_out;
int msg_size;
typedef struct test{
    unsigned long long int signal;
    char data[100];
} s_test;
int res;
s_test x;



void data(unsigned long long int signal, char text[100]){

strcpy(x.data, text);
x.signal = signal;

}


void kernel_space_sender(unsigned long long int addr){

data(addr, "from kernel to user NEW"); 


 //printk(KERN_INFO "Received message payload Kernel  irfan: %d - %s\n",  xy->a, xy->b);
 /*pid of sending process */

skb_out = nlmsg_new(msg_size,0);

if(!skb_out)
{

    printk(KERN_ERR "Failed to allocate new skb\n");
    return;

} 
nlh=nlmsg_put(skb_out,0,0,NLMSG_DONE,msg_size,0);  
NETLINK_CB(skb_out).dst_group = 0; /* not in mcast group */

//strncpy(nlmsg_data(nlh),msg,msg_size);
memcpy(nlmsg_data(nlh), &x, msg_size);
pid = 1;
res=nlmsg_unicast(nl_sk,skb_out,pid);
if(res<0)
    printk(KERN_INFO "Error while sending to user\n");
//printk(KERN_INFO "sending to user success\n");
// again message send

/*
strcpy(x.data, "Kernel Space Message again/again");
x.signal = 4444;
skb_out = nlmsg_new(msg_size,0);

if(!skb_out)
{

    printk(KERN_ERR "Failed to allocate again new skb\n");
    return;

} 
nlh=nlmsg_put(skb_out,0,0,NLMSG_DONE,msg_size,0);  
NETLINK_CB(skb_out).dst_group = 0; // not in mcast group 

//strncpy(nlmsg_data(nlh),msg,msg_size);
memcpy(nlmsg_data(nlh), &x, msg_size);

res=nlmsg_unicast(nl_sk,skb_out,pid);
if(res<0)
    printk(KERN_INFO "Error while sending bak to user\n");
*/

}



static void hello_nl_recv_msg(struct sk_buff *skb) {
//char *msg="Hello from kernel";

//This is for 3.6 kernels and above.

    
s_test *xy;

nlh=(struct nlmsghdr*)skb->data;
//printk(KERN_INFO "Netlink received msg payload irfan:%s\n",(char*)nlmsg_data(nlh));
 xy = (s_test *)NLMSG_DATA(nlh);

//printk(KERN_INFO "Entering irfan: %s\n", __FUNCTION__);

//msg_size=strlen(msg);
 
printk(KERN_INFO "Received message payload in Kernel  from USER: %lld - %s\n",  xy->signal, xy->data);
//pid = nlh->nlmsg_pid;

//data(xy->signal, xy->data);

//kernel_space_sender();
//data(3, "this is 3");
//kernel_space_sender();
//data(xy->signal*2, "from kernel to user NEW");
//msleep(1000);
kernel_space_sender(xy->signal*2);


}

void create_socket(unsigned long long int addr){
struct netlink_kernel_cfg cfg = {
    .input = hello_nl_recv_msg,
};
//printk("Entering irfan: %s\n",__FUNCTION__);
//This is for 3.6 kernels and above.


nl_sk = netlink_kernel_create(&init_net, NETLINK_USER, &cfg);
//nl_sk = netlink_kernel_create(&init_net, NETLINK_USER, 0, hello_nl_recv_msg,NULL,THIS_MODULE);
if(!nl_sk)
{

    printk(KERN_ALERT "Error creating socket.\n");
    nl_sk = netlink_kernel_create(&init_net, NETLINK_USER, &cfg);
    //return -10;

}
msg_size = sizeof(x);
msleep(3000);
//printk(KERN_INFO "sending data: %s\n", __FUNCTION__);


kernel_space_sender(addr);






return;

}