#include <sys/socket.h>
#include <linux/netlink.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define NETLINK_USER 31

#define MAX_PAYLOAD 1024 /* maximum payload size*/
struct sockaddr_nl src_addr, dest_addr;
struct nlmsghdr *nlh = NULL;
struct iovec iov;
int sock_fd;
struct msghdr msg;
typedef struct test{
    unsigned long long int signal;
    char data[100];
} s_test;
s_test x;
int msg_size;


void data(unsigned long long int signal, char text[100]){

strcpy(x.data, text);
x.signal = signal;

}


prepare_buffer_msg(){

bind(sock_fd, (struct sockaddr*)&src_addr, sizeof(src_addr));
msg_size = sizeof(x);
memset(&dest_addr, 0, sizeof(dest_addr));
dest_addr.nl_family = AF_NETLINK;
dest_addr.nl_pid = 0; /* For Linux Kernel */
dest_addr.nl_groups = 0; /* unicast */

nlh = (struct nlmsghdr *)malloc(NLMSG_SPACE(MAX_PAYLOAD));
memset(nlh, 0, NLMSG_SPACE(MAX_PAYLOAD));
nlh->nlmsg_len = NLMSG_SPACE(MAX_PAYLOAD);
//nlh->nlmsg_pid = getpid();
nlh->nlmsg_pid = 1;
nlh->nlmsg_flags = 0;
memcpy(NLMSG_DATA(nlh), &x, msg_size);
//printf("%d, %s\n", x.signal, x.data);
//strcpy(NLMSG_DATA(nlh), "Hello");
//strncpy(nlmsg_data(nlh),msg,msg_size);

iov.iov_base = (void *)nlh;
iov.iov_len = nlh->nlmsg_len;
msg.msg_name = (void *)&dest_addr;
msg.msg_namelen = sizeof(dest_addr);
msg.msg_iov = &iov;
msg.msg_iovlen = 1;


}



user_space_sender(unsigned long long int addr){
//	x.signal = 44;
//strcpy(x.data, "double user space");







data(addr*2, "user space NEW");


//printf("Sending message to kernel from user\n");
sendmsg(sock_fd,&msg,0);
}


user_space_receiver(){

x.signal = 1;
//sendmsg(sock_fd,&msg,0);
//printf("Waiting for message from kernel Irfan\n");

// Read message from kernel 
while(1){

 recvmsg(sock_fd, &msg, 0);
 s_test *xy = (s_test *)NLMSG_DATA(nlh);
printf("Received message payload from KERNEL: %lld - %s\n", xy->signal, xy->data);
//printf("recieve again from kernel?");
//scanf("%d", &x.signal );
//data(xy->signal*2, "user space NEW");

//user_space_sender(xy->signal);
}
//printf("Received message payload: %s\n", (char *)NLMSG_DATA(nlh));

close(sock_fd);

}





void main()
{

sock_fd=socket(PF_NETLINK, SOCK_RAW, NETLINK_USER);



int msg_size;
//printf("Enter roll number");
//scanf("%d", &x.signal );
//x.b[20] = "User";


msg_size = sizeof(x);
while(sock_fd<0){
	//printf("No kernel space process %d \n", sock_fd);
	sock_fd=socket(PF_NETLINK, SOCK_RAW, NETLINK_USER);


}

src_addr.nl_family = AF_NETLINK;

//src_addr.nl_pid = getpid(); /* self pid */
src_addr.nl_pid = 1; /* self pid */

prepare_buffer_msg();



user_space_receiver(sock_fd);
//data(x.signal, "double 3");

//user_space_sender(sock_fd);
// waiting from the reciever

}